package Bandiere;

import java.awt.BorderLayout;
import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.Border;

import Bandiere.ClientListener;

public class ClientFrame extends JFrame {

	NorthPanel north;
	CenterPanel center;
	SouthPanel south;
	
	public ClientFrame() {
		super("Daniele Compagnoni 2114420");
		
		 north = new NorthPanel();
		 center = new CenterPanel();
		 south = new SouthPanel();
		 
		 // Layout
		 add(north, BorderLayout.NORTH);
		 add(center, BorderLayout.CENTER);
		 add(south, BorderLayout.SOUTH);
		 
		 // Listener
		 ClientListener cl = new ClientListener(this);
		 north.connectButton.setActionCommand(ClientListener.Connect);
		 north.connectButton.addActionListener(cl);
		 north.disconnectButton.setActionCommand(ClientListener.Disconnect);
		 north.disconnectButton.addActionListener(cl);
		 south.startButton.setActionCommand(ClientListener.Start);
		 south.startButton.addActionListener(cl);
		 south.stopButton.setActionCommand(ClientListener.Stop);
		 south.stopButton.addActionListener(cl);
		 
		 updateUI(false, false);
		 pack();
		 setDefaultCloseOperation(EXIT_ON_CLOSE);
		 setLocationRelativeTo(null);
		 setVisible(true);
	}
	
	
	/*
	All’avvio solamente il pulsante ​Connect è abilitato. Non deve essere possibile avviare 2
	connessioni dallo stesso client spingendo ripetutamente il bottone.
	
	Start​ e ​Disconnect​ possono essere premuti solo se la connessione col server è già avviata
	
	Dopo la pressione di ​Start​ l’unico pulsante che può essere premuto è ​Stop​.

	Alla pressione di ​Stop dovranno tornare attivi solo i pulsanti ​Start e ​Disconnect​, per
	effettuare un nuovo download o disconnettersi dal server.
    */
	
	public void updateUI(boolean connected, boolean transmitting) {
		if (connected) {
			if (transmitting) {
				this.north.connectButton.setEnabled(false);
				this.north.disconnectButton.setEnabled(false);
				this.south.startButton.setEnabled(false);
				this.south.stopButton.setEnabled(true);
			} else {
				this.north.connectButton.setEnabled(false);
				this.north.disconnectButton.setEnabled(true);
				this.south.startButton.setEnabled(true);
				this.south.stopButton.setEnabled(false);
			}
		} else {
			this.north.connectButton.setEnabled(true);
			this.north.disconnectButton.setEnabled(false);
			this.south.startButton.setEnabled(false);
			this.south.stopButton.setEnabled(false);
		}
	}

}
